/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cd.hologram.erecettesvg.sql;

/**
 *
 * @author juslin.tshiamua
 */
public class SQLQueryGestionArticleBudgetaire {

    public static String SELECT_EXERCICE_FISCAL = "SELECT * FROM T_EXERCICE_FISCALE WITH (READPAST) WHERE ETAT = 1";

    public static String SELECT_AGENT = "SELECT * FROM T_AGENT WITH (READPAST) WHERE CODE = ?1";

    public static String EXEC_P_NEW_EXERCICE_FISCALE = "EXEC P_NEW_EXERCICE_FISCALE ?1,?2,?3,?4,?5";

    public static String EXEC_P_NEW_CLE_REPARTITION = "EXEC SP_ADD_CLE_REPARTITION ?1,?2,?3,?4,?5";

    public static String SELECT_CLE_REPARTITION_BY_CODE = "SELECT CL.* FROM T_CLE_REPARTITION CL WITH (READPAST) WHERE CL.FK_ARTICLE_BUDGETAIRE = ?1";
    public static String SELECT_CLE_REPARTITION_BY_CODE_TRESOR = "SELECT CL.* FROM T_CLE_REPARTITION CL WITH (READPAST) WHERE CL.FK_ARTICLE_BUDGETAIRE = ?1 AND IS_TRESOR_PART = 1";

    public static String DELETE_EXERCICE_FISCALE = "DELETE FROM T_EXERCICE_FISCALE WHERE CODE = ?1";

    public static String UPDATE_EXERCICE_FISCALE = "UPDATE T_EXERCICE_FISCALE WITH (READPAST) SET INTITULE = ?1, DEBUT = ?2, FIN = ?3, AGENT_MAJ = ?4, DATE_MAJ = GETDATE() WHERE CODE = ?5";

    public static String SELECT_ALL_MINISTERE = "SELECT * FROM T_SERVICE WITH (READPAST) WHERE ETAT = 1 AND SERVICE IS NULL";

    public static String SELECT_ALL_SERVICES = "SELECT * FROM T_SERVICE WITH (READPAST) WHERE ETAT = 1 AND SERVICE IS NOT NULL";

    public static String SELECT_ALL_SERVICES_ASSIETTES = "SELECT * FROM T_SERVICE";

    public static String SELECT_SERVICES_MINISTERE = "SELECT * FROM T_SERVICE WITH (READPAST) WHERE ETAT = 1 AND SERVICE IS NOT NULL AND SERVICE = ?1";

    public static String SELECT_FAITS_GENERATEURS_BY_SERVICE = "SELECT * FROM T_ARTICLE_GENERIQUE WHERE ETAT = 1 %s";

    public static String SELECT_FORMES_JURIDIQUES = "SELECT * FROM T_FORME_JURIDIQUE WIDTH(READPAST) WHERE ETAT = 1";

    public static String EXEC_P_NEW_ARTICLE_GENERIQUE = "EXEC F_NEW_ARTICLE_GENERIQUE ?1,?2,?3,?4";

    public static String EXEC_UPDATE_ARTICLE_GENERIQUE = "UPDATE T_ARTICLE_GENERIQUE SET INTITULE = ?1, SERVICE_ASSIETTE = ?2, FORME_JURIDIQUE = ?3 WHERE CODE = ?4";

    public static String EXEC_DELETE_ARTICLE_GENERIQUE = "UPDATE T_ARTICLE_GENERIQUE SET ETAT = 0 WHERE CODE = ?1";

    public static String EXEC_F_NEW_SERVICES = "EXEC F_NEW_SERVICES ?1,?2,?3";

    public static String UPDATE_SERVICE = "UPDATE T_SERVICE SET INTITULE = ?1 WHERE CODE = ?2";

    public static String ACTIVE_DEACTIVE_SERVICE = "UPDATE T_SERVICE WITH (READPAST) SET ETAT = ?1 WHERE CODE = ?2";

    public static String SELECT_ALL_SERVICES_MINISTERE = "SELECT * FROM T_SERVICE WITH (READPAST)";

    public static String SELECT_ALL_MINISTERE_V2 = "SELECT * FROM T_SERVICE WITH (READPAST) WHERE SERVICE IS NULL";

    public static String SELECT_DOCUMENT_OFFICIEL = "SELECT * FROM T_DOCUMENT_OFFICIEL WHERE ETAT = 1";

    public static String SELECT_NATURE_ARTICLE_BUDGETAIRE = "SELECT * FROM T_NATURE_ARTICLE_BUDGETAIRE WHERE ETAT = 1 order by intitule";

    public static String SELECT_ARTICLE_BUGDETAIRE = "SELECT * FROM T_ARTICLE_BUDGETAIRE WITH (READPAST) WHERE ETAT = 1 order by intitule";

    public static String SELECT_ARTICLE_BUGDETAIRE_GENERIQUE = "SELECT * FROM T_ARTICLE_BUDGETAIRE WITH (READPAST) WHERE ARTICLE_GENERIQUE = ?1";

    public static String SELECT_PERIODICITE = "SELECT * FROM T_PERIODICITE";

    public static String SELECT_ARTICLE_GENERIQUE = "SELECT * FROM T_ARTICLE_GENERIQUE";

    public static String SELECT_CLE_REPARTITION = "SELECT * FROM T_CLE_REPARTITION WHERE ETAT = 1 AND FK_ARTICLE_BUDGETAIRE = ''";

    public static String SELECT_ALL_CLE_REPARTITION = "SELECT * FROM T_CLE_REPARTITION";

    public static String F_CREATE_DOCUMENT_OFFICIEL = "EXEC F_NEW_DOC_OFFICIEL ?1, ?2, ?3";

    public static String F_UPDATE_DOCUMENT_OFFICIEL = "F_UPDATE_AGEN_WEB";

    public static String UPDATE_DOCUMENT_OFFICIEL = "UPDATE T_DOCUMENT_OFFICIEL SET INTITULE = ?1, DATE_ARRETE = ?2, NUMERO = ?3 WHERE CODE = ?4";

    public static String SELECT_DOCUMENT_OFFICIEL_BY_INTITULE = "SELECT D.* FROM T_DOCUMENT_OFFICIEL D WITH(READPAST) WHERE "
            + "( D.INTITULE LIKE ?1) AND D.ETAT = 1 ";
    public static String SELECT_DOCUMENT_OFFICIEL_BY_NUMERE_ARRETE = "SELECT D.* FROM T_DOCUMENT_OFFICIEL D WITH(READPAST) WHERE "
            + " D.NUMERO = ?1 AND D.ETAT = 1 ";

    public static String SQL_QUERY_LIST_ARTICLE_GENERIQUE_WITH_LIKE = " AND (AG.INTITULE LIKE ?1 OR S.INTITULE LIKE ?1) ORDER BY AG.INTITULE";

    public static String SELECT_MASTER_LIST_GESTIONNAIRE_ARTICLE_GENERIQUE = "SELECT AG.INTITULE, AG.CODE, AG.SERVICE_ASSIETTE, AG.FORME_JURIDIQUE,S.INTITULE "
            + " FROM T_ARTICLE_GENERIQUE AG LEFT JOIN T_SERVICE S ON AG.SERVICE_ASSIETTE = S.CODE WHERE AG.ETAT=1 %s";

    //public static String SELECT_DETAIL_ASSIGNATION_EXERCICE_SERVICE = "SELECT * FROM T_DETAILS_ASSIGNATION_BUDGETAIRE WITH (READPAST) WHERE FK_ASSIGNATION in(SELECT ID FROM T_ASSIGNATION_BUDGETAIRE WHERE FK_SERVICE = ?1 AND FK_EXERCICE = ?2)";
    public static String SELECT_DETAIL_ASSIGNATION_EXERCICE_SERVICE = "SELECT D.* FROM T_DETAILS_ASSIGNATION_BUDGETAIRE D INNER JOIN T_ASSIGNATION_BUDGETAIRE A ON D.FK_ASSIGNATION = A.ID "
            + "WHERE D.FK_ARTICLE_BUDGETAIRE IN (SELECT CODE FROM T_ARTICLE_BUDGETAIRE WHERE ARTICLE_GENERIQUE IN (SELECT CODE FROM T_ARTICLE_GENERIQUE WHERE SERVICE_ASSIETTE = ?1)) AND A.FK_EXERCICE = ?2";

    public static String SELECT_DETAIL_ASSIGNATION_EXERCICE_SERVICE_FGEN = " AND FK_ARTICLE_BUDGETAIRE IN(SELECT CODE FROM T_ARTICLE_BUDGETAIRE WHERE ARTICLE_GENERIQUE = %s)";

    public static String GET_PERIODICITE = "SELECT * FROM T_PERIODICITE WITH(READPAST) WHERE ETAT = 1 order by intitule";
    public static String GET_FORME_JURIDIQUE = "SELECT * FROM T_FORME_JURIDIQUE WITH(READPAST) WHERE ETAT = 1 order by intitule";
    public static String GET_DEVISE = "SELECT * FROM T_DEVISE WITH(READPAST) WHERE ETAT = 1 order by intitule";
    public static String GET_UNITE = "SELECT * FROM T_UNITE WITH(READPAST) WHERE ETAT = 1 order by intitule";

    public static String SELECT_TARIF_BY_INTITULE = "SELECT T.* FROM T_TARIF T WITH(READPAST) WHERE "
            + "( T.INTITULE LIKE ?1) AND T.ETAT = 1 ";
    
    public static String SELECT_TARIF_BY_INTITULE_FOR_PEAGE = "SELECT T.* FROM T_TARIF T WITH(READPAST) WHERE "
            + "( T.INTITULE LIKE ?1) AND T.ETAT = 1 AND EST_TARIF_PEAGE = 1 ORDER BY T.INTITULE";
    
    public static String SELECT_TARIF_BY_INTITULE_FOR_DRHKAT = "SELECT T.* FROM T_TARIF T WITH(READPAST) WHERE "
            + "( T.INTITULE LIKE ?1) AND T.ETAT = 1 AND EST_TARIF_PEAGE = 0 ORDER BY T.INTITULE";

    public static String F_NEW_ARTICLE_BUDGETAIRE_WEB = "F_NEW_ARTICLE_BUDGETAIRE_WEB";

    public static String F_NEW_ARTICLE_BUDGETAIRE_WEB_V2 = "F_NEW_ARTICLE_BUDGETAIRE_WEB_V2";

    public static String INSERT_PALIER = ":INSERT INTO T_PALIER(ARTICLE_BUDGETAIRE,BORNE_INFERIEURE "
            + ",BORNE_SUPERIEURE,TAUX,TYPE_TAUX,TARIF,TYPE_PERSONNE,ETAT,AGENT_CREAT "
            + ",DATE_CREAT,AGENT_MAJ,DATE_MAJ,MULTIPLIER_VALEUR_BASE,DEVISE,UNITE)"
            + " VALUES(?1,?2,?3,?4,?5,?6,?7,?8,?9,?10,?11,?12,?13,?14,?15)";

    public static String INSERT_PALIER_V2 = ":INSERT INTO T_PALIER(ARTICLE_BUDGETAIRE,BORNE_INFERIEURE "
            + ",BORNE_SUPERIEURE,TAUX,TYPE_TAUX,TARIF,TYPE_PERSONNE,ETAT,AGENT_CREAT "
            + ",DATE_CREAT,AGENT_MAJ,DATE_MAJ,MULTIPLIER_VALEUR_BASE,DEVISE,UNITE,FK_ENTITE_ADMINISTRATIVE,FK_TYPE_BIEN)"
            + " VALUES('%s',?1,?2,?3,?4,?5,?6,?7,?8,?9,?10,?11,?12,?13,?14,?15,?16)";

    public static String GET_GET_TOTAL_MONT_ASSIGNATION_AB;

    public static String SELECT_ARTICLE_BUGDETAIRE_GENERIQUE_ByCode = "SELECT * FROM T_ARTICLE_BUDGETAIRE WITH (READPAST) WHERE CODE = ?1";

    public static String SELECT_ASSIGNATION = "SELECT * FROM T_ASSIGNATION_BUDGETAIRE WHERE ID = ?1";
    public static String GET_DEVISE_FUNCTION = "SELECT [dbo].[F_GET_TOTAL_MONT_REALISAT_ONLY2]('%s','%s','%s','%s')";
    public static String GET_TOTAL_MONT_ASSIGNATION_AB = "SELECT [dbo].[F_GET_TOTAL_MONT_ASSIGNATION_AB ]('%s','%s','%s','%s')";

    public static String LOAD_ASSIGNATION_BY_EXERCICE = "SELECT * FROM T_ASSIGNATION_BUDGETAIRE WHERE FK_EXERCICE = ?1 AND ETAT = 1";

    public static String SELECT_BANQUE_SITE = "SELECT B.CODE, B.INTITULE, B.SIGLE "
            + "FROM T_BANQUE B WITH (READPAST) "
            + "WHERE B.ETAT=1 AND B.CODE IN (SELECT BANQUE "
            + "FROM T_SITE_BANQUE WITH (READPAST) "
            + "WHERE SITE = ?1)";

    public static String SELECT_COMPTE_BANQUE = "SELECT * FROM T_COMPTE_BANCAIRE "
            + "WITH (READPAST) WHERE BANQUE =?1 AND ETAT = 1 ";

    public static String SELECT_ARTICLE_BANQUE = "SELECT BA.* FROM T_BANQUE_AB BA WITH "
            + "(READPAST) INNER JOIN T_ARTICLE_BUDGETAIRE AR ON BA.FK_AB = AR.CODE %s";

    public static String SELECT_SERVICE_BY_MINISTRE = "SELECT * FROM T_SERVICE WITH (READPAST) "
            + "WHERE ETAT = 1 AND SERVICE = ?1";

    public static String SELECT_ARTICLE_BUDGETAIRE_BY_SERVICE = "SELECT AB.CODE, AB.INTITULE, AG.INTITULE "
            + "FROM T_ARTICLE_BUDGETAIRE AB WITH (READPAST) INNER JOIN "
            + "T_ARTICLE_GENERIQUE AG ON AB.ARTICLE_GENERIQUE=AG.CODE "
            + "WHERE AB.ETAT=1 AND AG.SERVICE_ASSIETTE = ?1 "
            + "AND AB.CODE NOT IN (SELECT FK_AB FROM T_BANQUE_AB WHERE "
            + "FK_COMPTE = ?2 AND ETAT = 1)";

    public static String AFFECTER_ARTICLE_COMPTE = ":INSERT INTO T_BANQUE_AB "
            + "(FK_BANQUE,FK_COMPTE,FK_AB,ETAT, AGENT_CREAT, DATE_CREAT) "
            + " VALUES (?1, ?2, ?3, ?4, ?5, ?6)";

    public static String DESAFFECTER_ARTICLE_COMPTE = ":DELETE FROM T_BANQUE_AB "
            + "WHERE ID = ?1";

    public static String SELECT_TARIF_FOR_PEAGE = "SELECT * FROM T_TARIF WITH(READPAST) WHERE ETAT = 1 AND EST_TARIF_PEAGE = 1 ORDER BY INTITULE";
    public static String SELECT_TARIF_FOR_DRHKAT = "SELECT * FROM T_TARIF WITH(READPAST) WHERE ETAT = 1 AND EST_TARIF_PEAGE = 0 ORDER BY INTITULE";

    public static String F_NEW_TARIF = "EXEC F_NEW_TARIF ?1,?2,?3,?4,?5";

    public static String DISABLE_TARIF = "UPDATE T_TARIF SET ETAT = 0 WHERE CODE = ?1";

    public static String UPDATE_TARIF = "UPDATE T_TARIF SET INTITULE = ?1, VALEUR = ?2, TYPE_VALEUR = ?3, AGENT_MAJ = ?4, DATE_MAJ = ?5,EST_TARIF_PEAGE = ?6 WHERE CODE = ?7";

    public static String F_NEW_PERIODICITE = "EXEC F_NEW_PERIODICITE ?1,?2,?3";

    public static String UPDATE_PERIODICITE = "UPDATE T_PERIODICITE SET INTITULE = ?1, NBR_JOUR = ?2, PERIODE_RECIDIVE = ?3 WHERE CODE = ?4";

    public static String DISABLE_PERIODICITE = "UPDATE T_PERIODICITE SET ETAT = 0 WHERE CODE = ?1";

    public static String SELECT_UNITE = "SELECT * FROM T_UNITE WITH(READPAST) WHERE ETAT = 1";

    public static String F_NEW_UNITE = "EXEC F_NEW_UNITE ?1,?2";

    public static String UPDATE_UNITE = "UPDATE T_UNITE SET INTITULE = ?1 WHERE CODE = ?2";

    public static String DISABLE_UNITE = "UPDATE T_UNITE SET ETAT = 0 WHERE CODE = ?1";

    public static String GET_COMMUNE_BY_VILEE = "SELECT A.* FROM T_ENTITE_ADMINISTRATIVE A WITH(READPAST) "
            + " WHERE ENTITE_MERE IN (SELECT AD.CODE FROM T_ENTITE_ADMINISTRATIVE AD WITH (READPAST)"
            + " WHERE AD.ENTITE_MERE = ?1 AND AD.ETAT = 1) AND A.ETAT = 1 order by A.INTITULE";

    public static String SELECT_ARTICLE_BUDGETAIRE_BY_CODE = "SELECT * FROM T_ARTICLE_BUDGETAIRE WITH (READPAST) "
            + "WHERE ETAT = 1 AND CODE = ?1";

    public static String SELECT_PALIER_BY_ARTICLE = "SELECT * FROM T_PALIER WITH (READPAST) "
            + "WHERE ETAT = 1 AND ARTICLE_BUDGETAIRE = ?1";

    public static String LOAD_ENTITE_ADMINISTRATIVE_BY_CODE = "SELECT * FROM T_ENTITE_ADMINISTRATIVE WITH (READPAST)"
            + " WHERE CODE = ?1 AND ETAT = 1";
    
    public static String LOAD_ENTITE_ADMINISTRATIVE_BY_CODE_V2 = "SELECT * FROM T_ENTITE_ADMINISTRATIVE WITH (READPAST)"
            + " WHERE CODE = ?1";

    public static String LOAD_DOCUMENT_OFFICIEL_BY_CODE = "SELECT * FROM T_DOCUMENT_OFFICIEL"
            + " WHERE CODE = ?1 AND ETAT = 1";

    public static String UPDATE_PALIER = ":UPDATE T_PALIER WITH (READPAST) SET ARTICLE_BUDGETAIRE = ?1, "
            + " BORNE_INFERIEURE = ?2, BORNE_SUPERIEURE = ?3, TAUX = ?4, TYPE_TAUX = ?5, TARIF = ?6, TYPE_PERSONNE = ?7,"
            + " AGENT_MAJ = ?8, DATE_MAJ = ?9, MULTIPLIER_VALEUR_BASE = ?10, DEVISE = ?11, UNITE = ?12, "
            + "FK_ENTITE_ADMINISTRATIVE = ?13, ETAT = ?14, FK_TYPE_BIEN = ?15 WHERE CODE = ?16";

    public static String UPDATE_ARTICLE_BUDGETAIRE = ":UPDATE T_ARTICLE_BUDGETAIRE WITH (READPAST) SET ARTICLE_GENERIQUE = ?1, "
            + "INTITULE = ?2, UNITE = ?3, PALIER = ?4, PERIODICITE = ?5, ASSUJETISSABLE = ?6, ARTICLE_MERE = ?7,"
            + " TARIF = ?8, TARIF_VARIABLE = ?9, AGENT_MAJ = ?10, DATE_MAJ = GETDATE(), PROPRIETAIRE = ?11, TRANSACTIONNEL = ?12, "
            + "DEBUT = ?13, FIN = ?14, PERIODICITE_VARIABLE = ?15, NBR_JOUR_LIMITE = ?16, NATURE = ?17, QUANTITE_VARIABLE = ?18, "
            + "ARRETE = ?19, CODE_OFFICIEL = ?20, DATE_DEBUT_PERIODE = ?21, DATE_DEBUT_PENALITE = ?22, ECHEANCE_LEGALE = ?23, "
            + "DATE_LIMITE_PAIEMENT = ?24, PERIODE_ECHEANCE = ?25 WHERE CODE = ?26";

    public static String INSERT_PALIER_V3 = ":INSERT INTO T_PALIER(ARTICLE_BUDGETAIRE,BORNE_INFERIEURE "
            + ",BORNE_SUPERIEURE,TAUX,TYPE_TAUX,TARIF,TYPE_PERSONNE,ETAT,AGENT_CREAT "
            + ",DATE_CREAT,AGENT_MAJ,DATE_MAJ,MULTIPLIER_VALEUR_BASE,DEVISE,UNITE,FK_ENTITE_ADMINISTRATIVE,FK_TYPE_BIEN)"
            + " VALUES(?1,?2,?3,?4,?5,?6,?7,?8,?9,?10,?11,?12,?13,?14,?15,?16,?17)";

    public static String GET_ARTICLE_BUDGETAIRE_BY_SERVICE = "SELECT AB.* "
            + "FROM T_ARTICLE_BUDGETAIRE AB WITH (READPAST) INNER JOIN "
            + "T_ARTICLE_GENERIQUE AG ON AB.ARTICLE_GENERIQUE=AG.CODE "
            + "WHERE AB.ETAT=1 AND AG.SERVICE_ASSIETTE = ?1 AND AG.ETAT = 1";

    public static String SELECT_ARTICLE_BUDGETAIRE_BY_INTITULE = "SELECT T.* FROM T_ARTICLE_BUDGETAIRE T WITH(READPAST) WHERE "
            + " T.INTITULE LIKE ?1 AND T.ETAT = 1 ";

    public static String LOAD_ENTITE_ADMINISTRATIVE_FILLE = "SELECT * FROM T_ENTITE_ADMINISTRATIVE WITH (READPAST)"
            + " WHERE ENTITE_MERE = ?1 AND ETAT = 1 AND TYPE_ENTITE =4 ";
    
    public static String LOAD_ENTITE_ADMINISTRATIVE_FILLE_V2= "SELECT * FROM T_ENTITE_ADMINISTRATIVE WITH (READPAST)"
            + " WHERE ENTITE_MERE = ?1 AND ETAT = 1 ";

    public static String SELECT_ARTICLE_BUDGETAIRE_BY_SERVICE_BY_INTITULE = "SELECT AB.* "
            + "FROM T_ARTICLE_BUDGETAIRE AB WITH (READPAST) INNER JOIN "
            + "T_ARTICLE_GENERIQUE AG ON AB.ARTICLE_GENERIQUE=AG.CODE "
            + "WHERE AB.ETAT=1 AND AG.SERVICE_ASSIETTE = ?1 AND AG.ETAT = 1 AND AB.INTITULE LIKE ?1";

    public static String SELECT_ARTICLE_BUDGETAIRE_BY_SERVICE_BY_INTITULE_V2 = "SELECT AB.* "
            + "FROM T_ARTICLE_BUDGETAIRE AB WITH (READPAST) INNER JOIN "
            + "T_ARTICLE_GENERIQUE AG ON AB.ARTICLE_GENERIQUE=AG.CODE "
            + "WHERE AB.ETAT=1 AND AG.ETAT = 1 AND AB.INTITULE LIKE ?1 %s";

    public static String LOAD_ENTITE_ADMINISTRATIVE_BY_TYPE = "SELECT * FROM T_ENTITE_ADMINISTRATIVE WITH (READPAST)"
            + " WHERE TYPE_ENTITE = ?1 AND ETAT = 1";

    public static String GET_ARTICLE_BUDGETAIRE_IMPOT = "SELECT * FROM T_ARTICLE_BUDGETAIRE WITH (READPAST) WHERE CODE IN (?1,?2,?3,?4,?5,?6)";
}
